function writeChangelog (version, done) {
  var pkg = require(process.cwd() + '/package'),
      template = require('lodash.template'),
      partial = require('lodash.partial'),
      commitTemplate = function (repository, commit) {
        // TODO - Make this configurable and default to Github, but include a Stash option
        var templateFn = repository ?
          template('[<%= commit %>](<%= repository %>/commits/<%= commit %>)') :
          template('<%= commit %>')
        return templateFn({
          repository: repository,
          commit: commit.substring(0,8) // no need to show super long hash in log
        })
      }

  console.info('Loading conventional-changelog')

  return require('conventional-changelog')({
    commitLink: partial(commitTemplate, pkg.repository.url),
    repository: pkg.repository.url,
    version: version
  }, function (err, log) {
    console.log('fudge')
    if (err) {
      console.error(err)
      throw new Error(err)
    } else {
      require('fs').writeFileSync(process.cwd() + '/CHANGELOG.md', log)
      return done && typeof done === 'function' && done()

    }
  })
}

module.exports = writeChangelog
